Package icyllis.modernui.transition

# Class TransitionManager

java.lang.Object
icyllis.modernui.transition.TransitionManager

public class TransitionManager extends Object
This class manages the set of transitions that fire when there is a change of `Scene`. To use the manager, add scenes along with transition objects with calls to `setTransition(Scene, Transition)` or `setTransition(Scene, Scene, Transition)`. Setting specific transitions for scene changes is not required; by default, a Scene change will use `AutoTransition` to do something reasonable for most situations. Specifying other transitions for particular scene changes is only necessary if the application wants different transition behavior in these situations.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TransitionManager()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `beginDelayedTransition(ViewGroup sceneRoot)`
  Convenience method to animate, using the default transition, to a new scene defined by all changes within the given scene root between calling this method and the next rendering frame.
  `static void`
  `beginDelayedTransition(ViewGroup sceneRoot, Transition transition)`
  Convenience method to animate to a new scene defined by all changes within the given scene root between calling this method and the next rendering frame.
  `static void`
  `endTransitions(ViewGroup sceneRoot)`
  Ends all pending and ongoing transitions on the specified scene root.
  `static void`
  `go(Scene scene)`
  Convenience method to simply change to the given scene using the default transition for TransitionManager.
  `static void`
  `go(Scene scene, Transition transition)`
  Convenience method to simply change to the given scene using the given transition.
  `void`
  `setTransition(Scene fromScene, Scene toScene, Transition transition)`
  Sets a specific transition to occur when the given pair of scenes is exited/entered.
  `void`
  `setTransition(Scene scene, Transition transition)`
  Sets a specific transition to occur when the given scene is entered.
  `void`
  `transitionTo(Scene scene)`
  Change to the given scene, using the appropriate transition for this particular scene change (as specified to the TransitionManager, or the default if no such transition exists).

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TransitionManager

    public TransitionManager()

- ## Method Details

  - ### setTransition

    public void setTransition(@Nonnull Scene scene, @Nullable Transition transition)
    Sets a specific transition to occur when the given scene is entered.
    Parameters:
      `scene` - The scene which, when applied, will cause the given transition to run.
      `transition` - The transition that will play when the given scene is entered. A value of null will result in the default behavior of using the default transition instead.

  - ### setTransition

    public void setTransition(@Nonnull Scene fromScene, @Nonnull Scene toScene, @Nullable Transition transition)
    Sets a specific transition to occur when the given pair of scenes is exited/entered.
    Parameters:
      `fromScene` - The scene being exited when the given transition will be run
      `toScene` - The scene being entered when the given transition will be run
      `transition` - The transition that will play when the given scene is entered. A value of null will result in the default behavior of using the default transition instead.

  - ### transitionTo

    public void transitionTo(@Nonnull Scene scene)
    Change to the given scene, using the appropriate transition for this particular scene change (as specified to the TransitionManager, or the default if no such transition exists).
    Parameters:
      `scene` - The Scene to change to

  - ### go

    public static void go(@Nonnull Scene scene)
    Convenience method to simply change to the given scene using the default transition for TransitionManager.
    Parameters:
      `scene` - The Scene to change to

  - ### go

    public static void go(@Nonnull Scene scene, @Nullable Transition transition)
    Convenience method to simply change to the given scene using the given transition.

    Passing in `null` for the transition parameter will result in the scene changing without any transition running, and is equivalent to calling `Scene.exit()` on the scene root's current scene, followed by `Scene.enter()` on the scene specified by the `scene` parameter.

    Parameters:
      `scene` - The Scene to change to
      `transition` - The transition to use for this scene change. A value of null causes the scene change to happen with no transition.

  - ### beginDelayedTransition

    public static void beginDelayedTransition(@Nonnull ViewGroup sceneRoot)
    Convenience method to animate, using the default transition, to a new scene defined by all changes within the given scene root between calling this method and the next rendering frame. Equivalent to calling `beginDelayedTransition(ViewGroup, Transition)` with a value of `null` for the `transition` parameter.
    Parameters:
      `sceneRoot` - The root of the View hierarchy to run the transition on.

  - ### beginDelayedTransition

    public static void beginDelayedTransition(@Nonnull ViewGroup sceneRoot, @Nullable Transition transition)
    Convenience method to animate to a new scene defined by all changes within the given scene root between calling this method and the next rendering frame. Calling this method causes TransitionManager to capture current values in the scene root and then post a request to run a transition on the next frame. At that time, the new values in the scene root will be captured and changes will be animated. There is no need to create a Scene; it is implied by changes which take place between calling this method and the next frame when the transition begins.

    Calling this method several times before the next frame (for example, if unrelated code also wants to make dynamic changes and run a transition on the same scene root), only the first call will trigger capturing values and exiting the current scene. Subsequent calls to the method with the same scene root during the same frame will be ignored.

    Passing in `null` for the transition parameter will cause the TransitionManager to use its default transition.

    Parameters:
      `sceneRoot` - The root of the View hierarchy to run the transition on.
      `transition` - The transition to use for this change. A value of null causes the TransitionManager to use the default transition.

  - ### endTransitions

    public static void endTransitions(ViewGroup sceneRoot)
    Ends all pending and ongoing transitions on the specified scene root.
    Parameters:
      `sceneRoot` - The root of the View hierarchy to end transitions on.